Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision 56699f009a608ecff3a247a08b3d0105a5e17153)
+++ protocols/yahoo/libyahoo2.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
@@ -1653,42 +1678,42 @@
 	int checksum = 0;
 	YList *l;
-	
-	for(l = pkt->hash; l; l = l->next)
-	{
+
+	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 
-		switch(pair->key)
-		{
+		switch (pair->key) {
 		case 1:
-		case 4:		/* sender */
+		case 4:	/* sender */
 			from = pair->value;
 			break;
-		case 5:		/* we */
+		case 5:	/* we */
 			to = pair->value;
 			break;
-		case 13:		/* request / sending */
-			status = atoi( pair->value );
-			break;
-		case 20:		/* url */
+		case 13:	/* request / sending */
+			status = atoi(pair->value);
+			break;
+		case 20:	/* url */
 			url = pair->value;
 			break;
 		case 192:	/*checksum */
-			checksum = atoi( pair->value );
-			break;
-		}
-	}
-
-	switch( status )
-	{
-		case 1:	/* this is a request, ignore for now */
-			YAHOO_CALLBACK(ext_yahoo_got_buddyicon_request)(yd->client_id, to, from);
-			break;
-		case 2:	/* this is cool - we get a picture :) */
-			YAHOO_CALLBACK(ext_yahoo_got_buddyicon)(yd->client_id,to, from, url, checksum);
-			break;
-	}
-}
-
-static void yahoo_process_picture_upload(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+			checksum = atoi(pair->value);
+			break;
+		}
+	}
+
+	switch (status) {
+	case 1:		/* this is a request, ignore for now */
+		YAHOO_CALLBACK(ext_yahoo_got_buddyicon_request) (yd->client_id,
+			to, from);
+		break;
+	case 2:		/* this is cool - we get a picture :) */
+		YAHOO_CALLBACK(ext_yahoo_got_buddyicon) (yd->client_id, to,
+			from, url, checksum);
+		break;
+	}
+}
+
+static void yahoo_process_picture_upload(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -1699,5 +1724,5 @@
 		return;		/* something went wrong */
 	
-	for(l = pkt->hash; l; l = l->next)
+	for (l = pkt->hash; l; l = l->next)
 	{
 		struct yahoo_pair *pair = l->data;
@@ -1717,5 +1742,5 @@
 	}
 
-	YAHOO_CALLBACK(ext_yahoo_buddyicon_uploaded)(yd->client_id, url);
+	YAHOO_CALLBACK(ext_yahoo_buddyicon_uploaded) (yd->client_id, url);
 }
 
@@ -1873,6 +1898,6 @@
 	const unsigned char *magic_ptr;
 
-	unsigned int  magic[64];
-	unsigned int  magic_work=0;
+	unsigned int magic[64];
+	unsigned int magic_work = 0;
 
 	char comparison_src[20];
@@ -1991,6 +2016,6 @@
 	
 	do { 
-		unsigned int     bl = 0;  
-		unsigned int     cl = magic[magic_cnt++]; 
+		unsigned int bl = 0;  
+		unsigned int cl = magic[magic_cnt++]; 
 		
 		if (magic_cnt >= magic_len) 
@@ -2018,5 +2043,5 @@
 	
 		
-	for(x = 0; x < 4; x++) 
+	for (x = 0; x < 4; x++) 
 		magic_key_char[x] = comparison_src[x];
 
@@ -2024,7 +2049,7 @@
 	memcpy( chal, magic_key_char, 4 );
         x = 1;
-	for( i = 0; i < 0xFFFF && x; i++ )
+	for ( i = 0; i < 0xFFFF && x; i++ )
 	{
-		for( j = 0; j < 5 && x; j++ )
+		for ( j = 0; j < 5 && x; j++ )
 		{
 			chal[4] = i;
@@ -2034,5 +2059,5 @@
 			md5_append( &ctx, chal, 7 );
 			md5_finish( &ctx, result );
-			if( memcmp( comparison_src + 4, result, 16 ) == 0 )
+			if ( memcmp( comparison_src + 4, result, 16 ) == 0 )
 			{
 				depth = i;
@@ -2110,7 +2135,7 @@
 
 	for (x = 0; x < 20; x += 2) {
-		unsigned int    val = 0;
-		unsigned int    lookup = 0;
-		char            byte[6];
+		unsigned int val = 0;
+		unsigned int lookup = 0;
+		char byte[6];
 
 		memset(&byte, 0, 6);
@@ -2353,15 +2378,15 @@
 	
 	if (req->status_code != 200) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 2000 + req->status_code, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 2000 + req->status_code, NULL);
 		goto fail;
 	}
 	
 	if (sscanf(req->reply_body, "%d", &st) != 1 || st != 0) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, yahoo_https_status_parse(st), NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, yahoo_https_status_parse(st), NULL);
 		goto fail;
 	}
 	
 	if ((had->token = yahoo_ha_find_key(req->reply_body, "ymsgr")) == NULL) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 3001, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 3001, NULL);
 		goto fail;
 	}
@@ -2409,10 +2434,10 @@
 
 	if (req->status_code != 200) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 2000 + req->status_code, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 2000 + req->status_code, NULL);
 		goto fail;
 	}
 	
 	if (sscanf(req->reply_body, "%d", &st) != 1 || st != 0) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, yahoo_https_status_parse(st), NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, yahoo_https_status_parse(st), NULL);
 		goto fail;
 	}
@@ -2421,5 +2446,5 @@
 	    (yd->cookie_t = yahoo_ha_find_key(req->reply_body, "T")) == NULL ||
 	    (crumb = yahoo_ha_find_key(req->reply_body, "crumb")) == NULL) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, 3002, NULL);
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, 3002, NULL);
 		goto fail;
 	}
@@ -2498,6 +2523,6 @@
 	char *login_id;
 	char *handle;
-	char *url=NULL;
-	int  login_status=0;
+	char *url = NULL;
+	int login_status = 0;
 
 	YList *l;
@@ -2515,11 +2540,12 @@
 	}
 
-	if(pkt->status == 0xffffffff) {
-		YAHOO_CALLBACK(ext_yahoo_login_response)(yd->client_id, login_status, url);
+	if (pkt->status == 0xffffffff) {
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, login_status, url);
 	/*	yahoo_logoff(yd->client_id);*/
 	}
 }
 
-static void yahoo_process_mail(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_mail(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2547,10 +2573,13 @@
 		char from[1024];
 		snprintf(from, sizeof(from), "%s (%s)", who, email);
-		YAHOO_CALLBACK(ext_yahoo_mail_notify)(yd->client_id, from, subj, count);
-	} else if(count > 0)
-		YAHOO_CALLBACK(ext_yahoo_mail_notify)(yd->client_id, NULL, NULL, count);
-}
-
-static void yahoo_process_contact(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		YAHOO_CALLBACK(ext_yahoo_mail_notify) (yd->client_id, from,
+			subj, count);
+	} else if (count > 0)
+		YAHOO_CALLBACK(ext_yahoo_mail_notify) (yd->client_id, NULL,
+			NULL, count);
+}
+
+static void yahoo_process_contact(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2561,5 +2590,5 @@
 	long tm = 0L;
 	int state = YAHOO_STATUS_AVAILABLE;
-	int online = FALSE;
+	int online = 0;
 	int away = 0;
 	int idle = 0;
@@ -2590,16 +2619,19 @@
 		else if (pair->key == 60)
 			mobile = strtol(pair->value, NULL, 10);
-		
+
 	}
 
 	if (id)
-		YAHOO_CALLBACK(ext_yahoo_contact_added)(yd->client_id, id, who, msg);
+		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, id, who,
+			msg);
 	else if (name)
-		YAHOO_CALLBACK(ext_yahoo_status_changed)(yd->client_id, name, state, msg, away, idle, mobile);
-	else if(pkt->status == 0x07)
-		YAHOO_CALLBACK(ext_yahoo_rejected)(yd->client_id, who, msg);
-}
-
-static void yahoo_process_buddyadd(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, name,
+			state, msg, away, idle, mobile);
+	else if (pkt->status == 0x07)
+		YAHOO_CALLBACK(ext_yahoo_rejected) (yd->client_id, who, msg);
+}
+
+static void yahoo_process_buddyadd(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2609,5 +2641,5 @@
 	char *me = NULL;
 
-	struct yahoo_buddy *bud=NULL;
+	struct yahoo_buddy *bud = NULL;
 
 	YList *l;
@@ -2624,13 +2656,11 @@
 	}
 
-	yahoo_dump_unhandled(pkt);
-
-	if(!who)
-		return;
-	if(!where)
+	if (!who)
+		return;
+	if (!where)
 		where = "Unknown";
 
 	/* status: 0 == Successful, 1 == Error (does not exist), 2 == Already in list */
-	if( status == 0 ) {
+	if ( status == 0 ) {
 		bud = y_new0(struct yahoo_buddy, 1);
 		bud->id = strdup(who);
@@ -2642,15 +2672,15 @@
 		/* Possibly called already, but at least the call above doesn't
 		   seem to happen every time (not anytime I tried). */
-		YAHOO_CALLBACK(ext_yahoo_contact_added)(yd->client_id, me, who, NULL);
-	}
-
-/*	YAHOO_CALLBACK(ext_yahoo_status_changed)(yd->client_id, who, status, NULL, (status==YAHOO_STATUS_AVAILABLE?0:1)); */
+		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, me, who, NULL);
+	}
+
+/*	YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, who, status, NULL, (status==YAHOO_STATUS_AVAILABLE?0:1)); */
 }
 
 static void yahoo_process_contact_ymsg13(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
 {
-	char* who=NULL;
-	char* me=NULL;	
-	char* msg=NULL;
+	char* who = NULL;
+	char* me = NULL;	
+	char* msg = NULL;
 	YList *l;
 	for (l = pkt->hash; l; l = l->next) {
@@ -2664,9 +2694,10 @@
 	}
 
-	if(pkt->status==3)
-		YAHOO_CALLBACK(ext_yahoo_contact_auth_request)(yid->yd->client_id, me, who, msg);
-}
-
-static void yahoo_process_buddydel(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	if (pkt->status==3)
+		YAHOO_CALLBACK(ext_yahoo_contact_auth_request) (yid->yd->client_id, me, who, msg);
+}
+
+static void yahoo_process_buddydel(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2691,10 +2722,11 @@
 			unk_66 = strtol(pair->value, NULL, 10);
 		else
-			DEBUG_MSG(("unknown key: %d = %s", pair->key, pair->value));
-	}
-
-	if(!who || !where)
-		return;
-	
+			DEBUG_MSG(("unknown key: %d = %s", pair->key,
+					pair->value));
+	}
+
+	if (!who || !where)
+		return;
+
 	bud = y_new0(struct yahoo_buddy, 1);
 	bud->id = strdup(who);
@@ -2707,5 +2739,5 @@
 	FREE(bud);
 
-	if(buddy) {
+	if (buddy) {
 		bud = buddy->data;
 		yd->buddies = y_list_remove_link(yd->buddies, buddy);
@@ -2717,14 +2749,15 @@
 		FREE(bud);
 
-		bud=NULL;
-	}
-}
-
-static void yahoo_process_ignore(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		bud = NULL;
+	}
+}
+
+static void yahoo_process_ignore(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *who = NULL;
-	int  status = 0;
+	int status = 0;
 	char *me = NULL;
-	int  un_ignore = 0;
+	int un_ignore = 0;
 
 	YList *l;
@@ -2735,25 +2768,25 @@
 		if (pair->key == 1)
 			me = pair->value;
-		if (pair->key == 13) /* 1 == ignore, 2 == unignore */ 
+		if (pair->key == 13)	/* 1 == ignore, 2 == unignore */
 			un_ignore = strtol(pair->value, NULL, 10);
-		if (pair->key == 66) 
+		if (pair->key == 66)
 			status = strtol(pair->value, NULL, 10);
 	}
-
 
 	/*
 	 * status
-	 * 	0  - ok
-	 * 	2  - already in ignore list, could not add
-	 * 	3  - not in ignore list, could not delete
-	 * 	12 - is a buddy, could not add
+	 *      0  - ok
+	 *      2  - already in ignore list, could not add
+	 *      3  - not in ignore list, could not delete
+	 *      12 - is a buddy, could not add
 	 */
 
 /*	if(status)
-		YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, who, 0, status);
-*/	
-}
-
-static void yahoo_process_voicechat(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, who, 0, status);
+*/
+}
+
+static void yahoo_process_voicechat(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *who = NULL;
@@ -2770,10 +2803,11 @@
 			me = pair->value;
 		if (pair->key == 13)
-			voice_room=pair->value;
-		if (pair->key == 57) 
-			room=pair->value;
-	}
-
-	NOTICE(("got voice chat invite from %s in %s to identity %s", who, room, me));
+			voice_room = pair->value;
+		if (pair->key == 57)
+			room = pair->value;
+	}
+
+	NOTICE(("got voice chat invite from %s in %s to identity %s", who, room,
+			me));
 	/* 
 	 * send: s:0 1:me 5:who 57:room 13:1
@@ -2787,8 +2821,9 @@
 }
 
-static void yahoo_process_ping(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_ping(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *errormsg = NULL;
-	
+
 	YList *l;
 	for (l = pkt->hash; l; l = l->next) {
@@ -2797,7 +2832,7 @@
 			errormsg = pair->value;
 	}
-	
+
 	NOTICE(("got ping packet"));
-	YAHOO_CALLBACK(ext_yahoo_got_ping)(yid->yd->client_id, errormsg);
+	YAHOO_CALLBACK(ext_yahoo_got_ping) (yid->yd->client_id, errormsg);
 }
 
@@ -2808,10 +2843,10 @@
 	char *data = NULL;
 	char *packet = NULL;
-	unsigned char magic_nr[] = {0, 1, 0};
+	unsigned char magic_nr[] = { 0, 1, 0 };
 	unsigned char header_len = 8;
 	unsigned int len = 0;
 	unsigned int pos = 0;
 
-	if(error || fd <= 0) {
+	if (error || fd <= 0) {
 		FREE(who);
 		FREE(yid);
@@ -2821,5 +2856,5 @@
 	yid->fd = fd;
 	inputs = y_list_prepend(inputs, yid);
-	
+
 	/* send initial packet */
 	if (who)
@@ -2831,6 +2866,5 @@
 
 	/* send data */
-	if (who)
-	{
+	if (who) {
 		data = strdup("g=");
 		data = y_string_append(data, who);
@@ -2851,8 +2885,11 @@
 	FREE(data);
 
-	yid->read_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, fd, YAHOO_INPUT_READ, yid);
-}
-
-static void yahoo_webcam_get_server(struct yahoo_input_data *y, char *who, char *key)
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+}
+
+static void yahoo_webcam_get_server(struct yahoo_input_data *y, char *who,
+	char *key)
 {
 	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
@@ -2862,15 +2899,17 @@
 	yid->yd = y->yd;
 	yid->wcm = y_new0(struct yahoo_webcam, 1);
-	yid->wcm->user = who?strdup(who):NULL;
-	yid->wcm->direction = who?YAHOO_WEBCAM_DOWNLOAD:YAHOO_WEBCAM_UPLOAD;
+	yid->wcm->user = who ? strdup(who) : NULL;
+	yid->wcm->direction = who ? YAHOO_WEBCAM_DOWNLOAD : YAHOO_WEBCAM_UPLOAD;
 	yid->wcm->key = strdup(key);
 
-	YAHOO_CALLBACK(ext_yahoo_connect_async)(yid->yd->client_id, yss->webcam_host, yss->webcam_port, 
-			_yahoo_webcam_get_server_connected, yid);
-
-}
-
-static YList *webcam_queue=NULL;
-static void yahoo_process_webcam_key(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	YAHOO_CALLBACK(ext_yahoo_connect_async) (yid->yd->client_id,
+		yss->webcam_host, yss->webcam_port,
+		_yahoo_webcam_get_server_connected, yid);
+
+}
+
+static YList *webcam_queue = NULL;
+static void yahoo_process_webcam_key(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *me = NULL;
@@ -2879,15 +2918,15 @@
 
 	YList *l;
-	// yahoo_dump_unhandled(pkt);
+	yahoo_dump_unhandled(pkt);
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 5)
 			me = pair->value;
-		if (pair->key == 61) 
-			key=pair->value;
+		if (pair->key == 61)
+			key = pair->value;
 	}
 
 	l = webcam_queue;
-	if(!l)
+	if (!l)
 		return;
 	who = l->data;
@@ -2898,10 +2937,9 @@
 }
 
-static void yahoo_packet_process(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_packet_process(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	DEBUG_MSG(("yahoo_packet_process: 0x%02x", pkt->service));
-	yahoo_dump_unhandled(pkt);
-	switch (pkt->service)
-	{
+	switch (pkt->service) {
 	case YAHOO_SERVICE_USERSTAT:
 	case YAHOO_SERVICE_LOGON:
@@ -3022,5 +3060,5 @@
 }
 
-static struct yahoo_packet * yahoo_getdata(struct yahoo_input_data * yid)
+static struct yahoo_packet *yahoo_getdata(struct yahoo_input_data *yid)
 {
 	struct yahoo_packet *pkt;
@@ -3029,5 +3067,5 @@
 	int pktlen;
 
-	if(!yd)
+	if (!yd)
 		return NULL;
 
@@ -3038,11 +3076,11 @@
 	}
 
-	pos += 4; /* YMSG */
+	pos += 4;		/* YMSG */
 	pos += 2;
 	pos += 2;
 
-	pktlen = yahoo_get16(yid->rxqueue + pos); pos += 2;
-	DEBUG_MSG(("%d bytes to read, rxlen is %d", 
-			pktlen, yid->rxlen));
+	pktlen = yahoo_get16(yid->rxqueue + pos);
+	pos += 2;
+	DEBUG_MSG(("%d bytes to read, rxlen is %d", pktlen, yid->rxlen));
 
 	if (yid->rxlen < (YAHOO_PACKET_HDRLEN + pktlen)) {
@@ -3056,9 +3094,12 @@
 	pkt = yahoo_packet_new(0, 0, 0);
 
-	pkt->service = yahoo_get16(yid->rxqueue + pos); pos += 2;
-	pkt->status = yahoo_get32(yid->rxqueue + pos); pos += 4;
+	pkt->service = yahoo_get16(yid->rxqueue + pos);
+	pos += 2;
+	pkt->status = yahoo_get32(yid->rxqueue + pos);
+	pos += 4;
 	DEBUG_MSG(("Yahoo Service: 0x%02x Status: %d", pkt->service,
-				pkt->status));
-	pkt->id = yahoo_get32(yid->rxqueue + pos); pos += 4;
+			pkt->status));
+	pkt->id = yahoo_get32(yid->rxqueue + pos);
+	pos += 4;
 
 	yd->session_id = pkt->id;
@@ -3068,10 +3109,11 @@
 	yid->rxlen -= YAHOO_PACKET_HDRLEN + pktlen;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + YAHOO_PACKET_HDRLEN 
-				+ pktlen, yid->rxlen);
+	if (yid->rxlen > 0) {
+		unsigned char *tmp = y_memdup(yid->rxqueue + YAHOO_PACKET_HDRLEN
+			+ pktlen, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3082,116 +3124,194 @@
 }
 
-static void yahoo_yab_read(struct yab *yab, unsigned char *d, int len)
+static struct yab *yahoo_yab_read(unsigned char *d, int len)
 {
 	char *st, *en;
 	char *data = (char *)d;
-	data[len]='\0';
+	struct yab *yab = NULL;
+
+	data[len] = '\0';
 
 	DEBUG_MSG(("Got yab: %s", data));
-	st = en = strstr(data, "userid=\"");
-	if(st) {
-		st += strlen("userid=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+	st = en = strstr(data, "e0=\"");
+	if (st) {
+		yab = y_new0(struct yab, 1);
+
+		st += strlen("e0=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->email = yahoo_xmldecode(st);
+	}
+
+	if (!en)
+		return NULL;
+
+	st = strstr(en, "id=\"");
+	if (st) {
+		st += strlen("id=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->yid = atoi(yahoo_xmldecode(st));
+	}
+
+	st = strstr(en, "fn=\"");
+	if (st) {
+		st += strlen("fn=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->fname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "ln=\"");
+	if (st) {
+		st += strlen("ln=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->lname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "nn=\"");
+	if (st) {
+		st += strlen("nn=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->nname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "yi=\"");
+	if (st) {
+		st += strlen("yi=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->id = yahoo_xmldecode(st);
 	}
 
-	st = strstr(en, "fname=\"");
-	if(st) {
-		st += strlen("fname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->fname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "lname=\"");
-	if(st) {
-		st += strlen("lname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->lname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "nname=\"");
-	if(st) {
-		st += strlen("nname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->nname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "email=\"");
-	if(st) {
-		st += strlen("email=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->email = yahoo_xmldecode(st);
-	}
-
 	st = strstr(en, "hphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("hphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->hphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "wphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("wphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->wphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "mphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("mphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->mphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "dbid=\"");
-	if(st) {
+	if (st) {
 		st += strlen("dbid=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->dbid = atoi(st);
 	}
-}
-
-static struct yab * yahoo_getyab(struct yahoo_input_data *yid)
+
+	return yab;
+}
+
+static struct yab *yahoo_getyab(struct yahoo_input_data *yid)
 {
 	struct yab *yab = NULL;
-	int pos = 0, end=0;
+	int pos = 0, end = 0;
 	struct yahoo_data *yd = yid->yd;
 
-	if(!yd)
+	if (!yd)
 		return NULL;
 
+	do {
+		DEBUG_MSG(("rxlen is %d", yid->rxlen));
+
+		if (yid->rxlen <= strlen("<ct"))
+			return NULL;
+
+		/* start with <ct */
+		while (pos < yid->rxlen - strlen("<ct") + 1
+			&& memcmp(yid->rxqueue + pos, "<ct", strlen("<ct")))
+			pos++;
+
+		if (pos >= yid->rxlen - 1)
+			return NULL;
+
+		end = pos + 2;
+		/* end with > */
+		while (end < yid->rxlen - strlen(">")
+			&& memcmp(yid->rxqueue + end, ">", strlen(">")))
+			end++;
+
+		if (end >= yid->rxlen - 1)
+			return NULL;
+
+		yab = yahoo_yab_read(yid->rxqueue + pos, end + 2 - pos);
+
+		yid->rxlen -= end + 1;
+		DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
+		if (yid->rxlen > 0) {
+			unsigned char *tmp =
+				y_memdup(yid->rxqueue + end + 1, yid->rxlen);
+			FREE(yid->rxqueue);
+			yid->rxqueue = tmp;
+			DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+					yid->rxqueue));
+		} else {
+			DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
+			FREE(yid->rxqueue);
+		}
+
+	} while (!yab && end < yid->rxlen - 1);
+
+	return yab;
+}
+
+static char *yahoo_getwebcam_master(struct yahoo_input_data *yid)
+{
+	unsigned int pos = 0;
+	unsigned int len = 0;
+	unsigned int status = 0;
+	char *server = NULL;
+	struct yahoo_data *yd = yid->yd;
+
+	if (!yid || !yd)
+		return NULL;
+
 	DEBUG_MSG(("rxlen is %d", yid->rxlen));
 
-	if(yid->rxlen <= strlen("<record"))
+	len = yid->rxqueue[pos++];
+	if (yid->rxlen < len)
 		return NULL;
 
-	/* start with <record */
-	while(pos < yid->rxlen-strlen("<record")+1 
-			&& memcmp(yid->rxqueue + pos, "<record", strlen("<record")))
-		pos++;
-
-	if(pos >= yid->rxlen-1)
-		return NULL;
-
-	end = pos+2;
-	/* end with /> */
-	while(end < yid->rxlen-strlen("/>")+1 && memcmp(yid->rxqueue + end, "/>", strlen("/>")))
-		end++;
-
-	if(end >= yid->rxlen-1)
-		return NULL;
-
-	yab = y_new0(struct yab, 1);
-	yahoo_yab_read(yab, yid->rxqueue + pos, end+2-pos);
-	
-
-	yid->rxlen -= end+1;
+	/* extract status (0 = ok, 6 = webcam not online) */
+	status = yid->rxqueue[pos++];
+
+	if (status == 0) {
+		pos += 2;	/* skip next 2 bytes */
+		server = y_memdup(yid->rxqueue + pos, 16);
+		pos += 16;
+	} else if (status == 6) {
+		YAHOO_CALLBACK(ext_yahoo_webcam_closed)
+			(yd->client_id, yid->wcm->user, 4);
+	}
+
+	/* skip rest of the data */
+
+	yid->rxlen -= len;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + end + 1, yid->rxlen);
+	if (yid->rxlen > 0) {
+		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3199,88 +3319,36 @@
 	}
 
-
-	return yab;
-}
-
-static char * yahoo_getwebcam_master(struct yahoo_input_data *yid)
-{
-	unsigned int pos=0;
-	unsigned int len=0;
-	unsigned int status=0;
-	char *server=NULL;
+	return server;
+}
+
+static int yahoo_get_webcam_data(struct yahoo_input_data *yid)
+{
+	unsigned char reason = 0;
+	unsigned int pos = 0;
+	unsigned int begin = 0;
+	unsigned int end = 0;
+	unsigned int closed = 0;
+	unsigned char header_len = 0;
+	char *who;
+	int connect = 0;
 	struct yahoo_data *yd = yid->yd;
 
-	if(!yid || !yd)
-		return NULL;
+	if (!yd)
+		return -1;
+
+	if (!yid->wcm || !yid->wcd || !yid->rxlen)
+		return -1;
 
 	DEBUG_MSG(("rxlen is %d", yid->rxlen));
 
-	len = yid->rxqueue[pos++];
-	if (yid->rxlen < len)
-		return NULL;
-
-	/* extract status (0 = ok, 6 = webcam not online) */
-	status = yid->rxqueue[pos++];
-
-	if (status == 0)
-	{
-		pos += 2; /* skip next 2 bytes */
-		server =  y_memdup(yid->rxqueue+pos, 16);
-		pos += 16;
-	}
-	else if (status == 6)
-	{
-		YAHOO_CALLBACK(ext_yahoo_webcam_closed)
-			(yd->client_id, yid->wcm->user, 4);
-	}
-
-	/* skip rest of the data */
-
-	yid->rxlen -= len;
-	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
-		FREE(yid->rxqueue);
-		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	} else {
-		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
-		FREE(yid->rxqueue);
-	}
-
-	return server;
-}
-
-static int yahoo_get_webcam_data(struct yahoo_input_data *yid)
-{
-	unsigned char reason=0;
-	unsigned int pos=0;
-	unsigned int begin=0;
-	unsigned int end=0;
-	unsigned int closed=0;
-	unsigned char header_len=0;
-	char *who;
-	int connect=0;
-	struct yahoo_data *yd = yid->yd;
-
-	if(!yd)
-		return -1;
-
-	if(!yid->wcm || !yid->wcd || !yid->rxlen)
-		return -1;
-
-	DEBUG_MSG(("rxlen is %d", yid->rxlen));
-
 	/* if we are not reading part of image then read header */
-	if (!yid->wcd->to_read)
-	{
-		header_len=yid->rxqueue[pos++];
-		yid->wcd->packet_type=0;
+	if (!yid->wcd->to_read) {
+		header_len = yid->rxqueue[pos++];
+		yid->wcd->packet_type = 0;
 
 		if (yid->rxlen < header_len)
 			return 0;
 
-		if (header_len >= 8)
-		{
+		if (header_len >= 8) {
 			reason = yid->rxqueue[pos++];
 			/* next 2 bytes should always be 05 00 */
@@ -3290,6 +3358,5 @@
 			yid->wcd->to_read = yid->wcd->data_size;
 		}
-		if (header_len >= 13)
-		{
+		if (header_len >= 13) {
 			yid->wcd->packet_type = yid->rxqueue[pos++];
 			yid->wcd->timestamp = yahoo_get32(yid->rxqueue + pos);
@@ -3303,5 +3370,6 @@
 	begin = pos;
 	pos += yid->wcd->to_read;
-	if (pos > yid->rxlen) pos = yid->rxlen;
+	if (pos > yid->rxlen)
+		pos = yid->rxlen;
 
 	/* if it is not an image then make sure we have the whole packet */
@@ -3316,5 +3384,5 @@
 
 	DEBUG_MSG(("packet type %.2X, data length %d", yid->wcd->packet_type,
-		yid->wcd->data_size));
+			yid->wcd->data_size));
 
 	/* find out what kind of packet we got */
@@ -3332,5 +3400,5 @@
 					who = y_memdup(yid->rxqueue + begin, end - begin);
 					who[end - begin - 1] = 0;
-					YAHOO_CALLBACK(ext_yahoo_webcam_viewer)(yd->client_id, who + 2, 2);
+					YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id, who + 2, 2);
 					FREE(who);
 				}
@@ -3342,5 +3410,5 @@
 				/* 1 = accepted viewing permission */
 				if (yid->wcd->timestamp == 0) {
-					YAHOO_CALLBACK(ext_yahoo_webcam_closed)(yd->client_id, yid->wcm->user, 3);
+					YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id, yid->wcm->user, 3);
 				}
 			}
@@ -3351,5 +3419,5 @@
 			break;
 		case 0x02: /* image data */
-			YAHOO_CALLBACK(ext_yahoo_got_webcam_image)(yd->client_id, 
+			YAHOO_CALLBACK(ext_yahoo_got_webcam_image) (yd->client_id, 
 					yid->wcm->user, yid->rxqueue + begin,
 					yid->wcd->data_size, pos - begin,
@@ -3358,5 +3426,5 @@
 		case 0x05: /* response packets when uploading */
 			if (!yid->wcd->data_size) {
-				YAHOO_CALLBACK(ext_yahoo_webcam_data_request)(yd->client_id, yid->wcd->timestamp);
+				YAHOO_CALLBACK(ext_yahoo_webcam_data_request) (yd->client_id, yid->wcd->timestamp);
 			}
 			break;
@@ -3371,5 +3439,5 @@
 					break;
 			}
-			YAHOO_CALLBACK(ext_yahoo_webcam_closed)(yd->client_id, yid->wcm->user, closed);
+			YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id, yid->wcm->user, closed);
 			break;
 		case 0x0C: /* user connected */
@@ -3379,14 +3447,14 @@
 				who[pos - begin] = 0;
 				if (yid->wcd->packet_type == 0x0C)
-					connect=1;
+					connect = 1;
 				else
-					connect=0;
-				YAHOO_CALLBACK(ext_yahoo_webcam_viewer)(yd->client_id, who, connect);
+					connect = 0;
+				YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id, who, connect);
 				FREE(who);
 			}
 			break;
 		case 0x13: /* user data */
-			/* i=user_ip (ip of the user we are viewing) */
-			/* j=user_ext_ip (external ip of the user we */
+			/* i = user_ip (ip of the user we are viewing) */
+			/* j = user_ext_ip (external ip of the user we */
  			/*                are viewing) */
 			break;
@@ -3422,5 +3490,5 @@
 
 	LOG(("write callback: id=%d fd=%d data=%p", id, fd, data));
-	if(!yid || !yid->txqueues || !find_conn_by_id(id))
+	if (!yid || !yid->txqueues || !find_conn_by_id(id))
 		return -2;
 	
@@ -3429,12 +3497,12 @@
 	len = yahoo_send_data(fd, tx->queue, MIN(1024, tx->len));
 
-	if(len == -1 && errno == EAGAIN)
+	if (len == -1 && errno == EAGAIN)
 		return 1;
 
-	if(len <= 0) {
+	if (len <= 0) {
 		int e = errno;
 		DEBUG_MSG(("len == %d (<= 0)", len));
-		while(yid->txqueues) {
-			YList *l=yid->txqueues;
+		while (yid->txqueues) {
+			YList *l = yid->txqueues;
 			tx = l->data;
 			free(tx->queue);
@@ -3444,7 +3512,7 @@
 		}
 		LOG(("yahoo_write_ready(%d, %d) len < 0", id, fd));
-		YAHOO_CALLBACK(ext_yahoo_remove_handler)(id, yid->write_tag);
+		YAHOO_CALLBACK(ext_yahoo_remove_handler) (id, yid->write_tag);
 		yid->write_tag = 0;
-		errno=e;
+		errno = e;
 		return 0;
 	}
@@ -3452,10 +3520,10 @@
 
 	tx->len -= len;
-	if(tx->len > 0) {
+	if (tx->len > 0) {
 		unsigned char *tmp = y_memdup(tx->queue + len, tx->len);
 		FREE(tx->queue);
 		tx->queue = tmp;
 	} else {
-		YList *l=yid->txqueues;
+		YList *l = yid->txqueues;
 		free(tx->queue);
 		free(tx);
@@ -3463,10 +3531,10 @@
 		y_list_free_1(l);
 		/*
-		if(!yid->txqueues) 
+		if (!yid->txqueues) 
 			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
 		*/
-		if(!yid->txqueues) {
+		if (!yid->txqueues) {
 			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
-			YAHOO_CALLBACK(ext_yahoo_remove_handler)(id, yid->write_tag);
+			YAHOO_CALLBACK(ext_yahoo_remove_handler) (id, yid->write_tag);
 			yid->write_tag = 0;
 		}
@@ -3482,5 +3550,5 @@
 	int id = yd->client_id;
 
-	if(over)
+	if (over)
 		return;
 
@@ -3500,9 +3568,9 @@
 static void yahoo_process_chatcat_connection(struct yahoo_input_data *yid, int over)
 {
-	if(over)
+	if (over)
 		return;
 
 	if (strstr((char*)yid->rxqueue+(yid->rxlen-20), "</content>")) {
-		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml)(yid->yd->client_id, (char*)yid->rxqueue);
+		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml) (yid->yd->client_id, (char*)yid->rxqueue);
 	}
 }
@@ -3513,22 +3581,22 @@
 	struct yab *yab;
 	YList *buds;
-	int changed=0;
+	int changed = 0;
 	int id = yd->client_id;
 
-	if(over)
-		return;
-
-	while(find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB) 
+	if (over)
+		return;
+
+	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB) 
 			&& (yab = yahoo_getyab(yid)) != NULL) {
-		if(!yab->id)
+		if (!yab->id)
 			continue;
-		changed=1;
-		for(buds = yd->buddies; buds; buds=buds->next) {
-			struct yahoo_buddy * bud = buds->data;
-			if(!strcmp(bud->id, yab->id)) {
+		changed = 1;
+		for (buds = yd->buddies; buds; buds = buds->next) {
+			struct yahoo_buddy *bud = buds->data;
+			if (!strcmp(bud->id, yab->id)) {
 				bud->yab_entry = yab;
-				if(yab->nname) {
+				if (yab->nname) {
 					bud->real_name = strdup(yab->nname);
-				} else if(yab->fname && yab->lname) {
+				} else if (yab->fname && yab->lname) {
 					bud->real_name = y_new0(char, 
 							strlen(yab->fname)+
@@ -3537,5 +3605,5 @@
 					sprintf(bud->real_name, "%s %s",
 							yab->fname, yab->lname);
-				} else if(yab->fname) {
+				} else if (yab->fname) {
 					bud->real_name = strdup(yab->fname);
 				}
